ChannelException (Apache Tomcat 8.5.83 API Documentation)

Package org.apache.catalina.tribes

## Class ChannelException

- java.lang.Object
- - java.lang.Throwable
  - - java.lang.Exception
    - - org.apache.catalina.tribes.ChannelException

- All Implemented Interfaces:
    `java.io.Serializable`

      public class ChannelException
      extends java.lang.Exception

  Channel Exception
  A channel exception is thrown when an internal error happens somewhere in the channel.
  When a global error happens, the cause can be retrieved using `getCause()`
  If an application is sending a message and some of the recipients fail to receive it, the application can retrieve what recipients failed by using the `getFaultyMembers()` method. This way, an application will always know if a message was delivered successfully or not.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `ChannelException.FaultyMember` | Title: FaultyMember class

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected static ChannelException.FaultyMember[]` | `EMPTY_LIST` | Empty list to avoid reinstantiating lists

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ChannelException()` | Constructor, creates a ChannelException
    `ChannelException​(java.lang.String message)` | Constructor, creates a ChannelException with an error message
    `ChannelException​(java.lang.String message, java.lang.Throwable cause)` | Constructor, creates a ChannelException with an error message and a cause
    `ChannelException​(java.lang.Throwable cause)` | Constructor, creates a ChannelException with a cause

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `addFaultyMember​(ChannelException.FaultyMember mbr)` | Adds a faulty member
    `int` | `addFaultyMember​(ChannelException.FaultyMember[] mbrs)` | Adds a list of faulty members
    `boolean` | `addFaultyMember​(Member mbr, java.lang.Exception x)` | Adds a faulty member, and the reason the member failed.
    `ChannelException.FaultyMember[]` | `getFaultyMembers()` | Returns an array of members that failed and the reason they failed.
    `java.lang.String` | `getMessage()` | Returns the message for this exception

    - ### Methods inherited from class java.lang.Throwable

      `addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### EMPTY_LIST

          protected static final ChannelException.FaultyMember[] EMPTY_LIST

      Empty list to avoid reinstantiating lists

  - ### Constructor Detail

    - #### ChannelException

          public ChannelException()

      Constructor, creates a ChannelException
      See Also:
        `Exception()`

    - #### ChannelException

          public ChannelException​(java.lang.String message)

      Constructor, creates a ChannelException with an error message
      Parameters:
        `message` - The error message
      See Also:
        `Exception(String)`

    - #### ChannelException

          public ChannelException​(java.lang.String message,
                                  java.lang.Throwable cause)

      Constructor, creates a ChannelException with an error message and a cause
      Parameters:
        `message` - The error message
        `cause` - Throwable
      See Also:
        `Exception(String,Throwable)`

    - #### ChannelException

          public ChannelException​(java.lang.Throwable cause)

      Constructor, creates a ChannelException with a cause
      Parameters:
        `cause` - Throwable
      See Also:
        `Exception(Throwable)`

  - ### Method Detail

    - #### getMessage

          public java.lang.String getMessage()

      Returns the message for this exception
      Overrides:
        `getMessage` in class `java.lang.Throwable`
      Returns:
        the error message
      See Also:
        `Throwable.getMessage()`

    - #### addFaultyMember

          public boolean addFaultyMember​(Member mbr,
                                         java.lang.Exception x)

      Adds a faulty member, and the reason the member failed.
      Parameters:
        `mbr` - Member
        `x` - Exception
      Returns:
        `true` if the member was added

    - #### addFaultyMember

          public int addFaultyMember​(ChannelException.FaultyMember[] mbrs)

      Adds a list of faulty members
      Parameters:
        `mbrs` - FaultyMember[]
      Returns:
        the number of members added

    - #### addFaultyMember

          public boolean addFaultyMember​(ChannelException.FaultyMember mbr)

      Adds a faulty member
      Parameters:
        `mbr` - FaultyMember
      Returns:
        `true` if the member was added

    - #### getFaultyMembers

          public ChannelException.FaultyMember[] getFaultyMembers()

      Returns an array of members that failed and the reason they failed.
      Returns:
        FaultyMember[]